
(* The type of tokens. *)

type token = 
  | TRUE
  | STRING of (string)
  | SOURCE
  | SEMICOLON
  | RPAREN
  | REGEXP of (Types.regexp)
  | RBRACKET
  | OR
  | NOT
  | MATCH
  | LT
  | LPAREN
  | LE
  | LBRACKET
  | IDENT of (string)
  | GT
  | GE
  | FIELD of (Types.field)
  | FALSE
  | EQ
  | EOF
  | AND

(* This exception is raised by the monolithic API functions. *)

exception Error

(* The monolithic API. *)

val full_expr: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Types.expr)

val config_file: (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (Types.expr Core.StringMap.t)
